//
//  DaoAdapter.swift
//  IngDao
//
//  Created by Gan Yew on 19/10/2020.
//  Copyright © 2020 Gan Yew. All rights reserved.
//

import UIKit

public protocol DaoAdapter: class {
    
    func startInit(_ callback: ((Error?) -> Void)?)
    
    func fetchFor(_ key: String, query: String, params: Dictionary<String, Any>, callback: (([Any]?,Error?) -> Void)?)
    
    func saveFor(_ key: String, params: Dictionary<String, Any>, callback: ((Any?,Error?) -> Void)?)
    
    func deleteFor(_ key: String, params: Dictionary<String, Any>, callback: ((Any?,Error?) -> Void)?)
}
