import 'package:ingdao/dataflow/field/dfbasefield.dart';
import 'package:ingdao/dataflow/repository/dfbaserepository.dart';
import '../../data_factory.dart';
import '../../entity/tanktimesheet/tanktimesheet.dart';
import '../../entity/tanktimesheet/tanktimesheetweb.dart';

abstract class TankTimesheetField {

  DfBaseField fId;
  DfBaseField fTankId;
  DfBaseField fName;
  DfBaseField fMarkOn;
  DfBaseField fActive;

  static TankTimesheetField createFieldBasedOnRepo(DfBaseRepository repo) {
    switch (repo.model.name) {
      case REPO_NAME_SQLITEDB :
        return TankTimesheet();
      case REPO_NAME_WEB :
        return TankTimesheetWeb();
    }
    return null;
  }
}