import 'package:flutter/material.dart';
import 'feature/userlist/service/applservice.dart';
import 'feature/userlist/ui/userlistscr.dart';

void main() {
  runApp(MaterialApp(
          title: "Data Layer - Loading",
          theme: ThemeData(primarySwatch: Colors.teal),
          home: SplashScr()
  )
  );
}

class SplashScr extends StatelessWidget {
  final AppService appService = AppService();

  _loadAppService(BuildContext context) async {
    await appService.startInit();
      Navigator.pushReplacement(
      context,
      MaterialPageRoute(builder: (context) => UserListScr(appService: appService))
    );
  }

  @override
  Widget build(BuildContext context) {
    _loadAppService(context);
    return Scaffold(
      body: Container(
                      color: Colors.teal,
                      child: Center(
                              child: 
                                      Column(
                                        mainAxisAlignment: MainAxisAlignment.center,
                                        crossAxisAlignment: CrossAxisAlignment.center,
                                        children: [
                                          Padding(padding: const EdgeInsets.all(16), child: Text("Data loading...", style: TextStyle(color: Colors.white))),
                                          CircularProgressIndicator(backgroundColor: Colors.white,)
                                        ]
                                      )
                            )
                    )
    );
  }
}