import 'package:meta/meta.dart';
import '../field/dfbasefield.dart';
import '../field/dfdbfield.dart';
import '../control/dfconverter.dart';
import '../control/dfquery.dart';
import 'package:object_mapper/object_mapper.dart';


abstract class DfBaseEntity<T extends DfBaseField> with Mappable {

  String entityName;
  List<T> fields();

  DfBaseEntity({@required this.entityName}) {
    // if (Mappable.factories == null)
    //   Mappable.factories = {};
    // Mappable.factories.addAll({newInstance().runtimeType: () => newInstance()});
  }

  @override
  void mapping(Mapper map) {
    doYourJsonMap(map, fields());
  }

  void doYourJsonMap(Mapper map, List<T> fields) {    
  }

  void customFieldJsonMap(Mapper map, List<T> fields);

  fromMap(Map<String,dynamic> dict) {
    fields().forEach((field) => field.setValueFromQueryResult(dict));
  }

  Map<DfBaseField, dynamic> toMap() {
    Map<String,dynamic> json = toJson();
    if (json != null) {
      for (DfBaseField field in fields()) {
        String fieldName = field.name;
        if (field is DfDbField) {
          fieldName = field.getSelectQueryAlias();
        }

        if (field.fieldType.isDateTime) {
          if (json[fieldName] != null && json[fieldName] is String && json[fieldName].length > 0)
            field.value = DfConverter.stringToDate(json[fieldName]);
        }
        else {
          field.value = json[fieldName];
        }
      }
    }

    Map<DfBaseField,dynamic> result = Map<DfBaseField,dynamic>();
    fields().where((field) => field.displayOnly == null || !field.displayOnly).forEach((field) => result[field] = field.value);
    return result;
  }

  DfBaseEntity<T> parseExecRawJsonResultToEntity(DfQueryPurpose queryPurpose, Mapper map);

  DfBaseField getSelectQueryCountField();

  DfBaseEntity newInstance();
}