import '../control/dfresponse.dart';
import 'dfbasefield.dart';

class AllowEmptyValidateException extends DfError {
   AllowEmptyValidateException() : super(code: 10001, message: "Value empty is not allowed");
}

class DfValidator {

  DfBaseField field;
  bool isAllowEmpty = true;

  DfValidator({this.isAllowEmpty = true});

  AllowEmptyValidateException emptyValidate() {
    if (!isAllowEmpty) {
      if (field.value == null) {
        return AllowEmptyValidateException();
      }
      else if (field.value is String && field.value == "") {
        return AllowEmptyValidateException();
      }
    }
    return null;
  }

  List<DfError> validate() {
    List<DfError> errors = List<DfError>();
    DfError emptyErr = emptyValidate();
    if (emptyErr != null) {
      errors.add(emptyErr);
    }

    return errors.length > 0 ? errors : null;
  }

}