import 'package:meta/meta.dart';
import 'dfbasefield.dart';
import '../entity/dfbaseentity.dart';
import '../field/dffieldtype.dart';
import '../control/dfconverter.dart';

class DfWebField extends DfBaseField {

  DfWebField({@required DfBaseEntity entity, @required String name, @required DfFieldType fieldType, Function getObjectValue, Function setObjectValue, dynamic value}) : super(entity: entity, name: name, fieldType: fieldType, getObjectValue: getObjectValue, setObjectValue: setObjectValue, value: value);

  setValueFromQueryResult(Map<String,dynamic> dict) {
    value = dict["$name"];
    if (value != null) {
      if (fieldType.isDateTime && value is String && value.length > 0) {
        value = DfConverter.stringToDate(value);
      }
      else if (fieldType.isBoolean && value is int) {
        value = DfConverter.intToBool(value);
      }
    }    
  }
}