import 'package:meta/meta.dart';
import '../entity/dfbaseentity.dart';
import 'package:object_mapper/object_mapper.dart';

abstract class DfBaseModel<T extends DfBaseEntity> {
  String name;
  bool encrypt;
  List<T> entities;

  DfBaseModel({@required this.name, this.encrypt, this.entities}) {
    if (Mappable.factories == null) {
      Mappable.factories = {};
    }
    if (entities != null) {
      for (var ent in entities) {
        DfBaseEntity entity = ent;
        final obj = entity.newInstance();
        Mappable.factories.addAll({obj.runtimeType: () => entity.newInstance()});  
      }
    }
  }
}