import 'package:meta/meta.dart';
import 'dfbasemodel.dart';
import '../entity/dfwebentity.dart';

enum SslPinningCriShaType {
  SHA1,
  SHA256
}

extension SslPinningCriShaTypeExtension on SslPinningCriShaType {

  String get name {
    switch (this) {
      case SslPinningCriShaType.SHA1:
        return 'sha1';
      case SslPinningCriShaType.SHA256:
        return 'sha256';
      default:
        return null;
    }
  }

  String desp() {
    return this.name;
  }
}

class SslPinningCri {
  List<String> shakeys;
  SslPinningCriShaType shatype;

  SslPinningCri({this.shakeys, this.shatype});
}

class DfWebModel extends DfBaseModel<DfWebEntity> {
  String serverUrl;
  Map<String,String> commonHeaders;
  SslPinningCri sslPinningCri;

  DfWebModel({@required String name, @required bool encrypt, @required this.serverUrl, @required List<DfWebEntity> entities, this.commonHeaders, this.sslPinningCri}) : super(name: name, encrypt: encrypt, entities: entities);

  static Map<String,String> formJsonHeader() {
    Map<String,String> headers = Map<String,String>();

    headers["Content-Type"] = "application/json";
    headers["Accept"] = "application/json";

    return headers;  
  }

}