import '../model/dfbasemodel.dart';
import 'package:meta/meta.dart';
import '../control/dfresponse.dart';
import '../control/dfquery.dart';

abstract class DfBaseRepository<T extends DfBaseModel> {

  T model;

  DfBaseRepository({@required this.model});

  Future<void> startInit();
  Future<void> stop();  
  Future<DfResponse> fetch(DfQuery query);
  Future<List<DfResponse>> save(List<DfQuery> queries);
  Future<List<DfResponse>> delete(List<DfQuery> queries);

  Future<DfResponse> fetchCount(DfQuery query) async {
    DfResponse resp = DfResponse();
    DfResponse resultSet = await(fetch(query));
    resp.error = resultSet.error;
    resp.fetchCountData = 0;
    if (resultSet.result != null) {
      resultSet.result.forEach((rec) {
        rec.forEach((key,val) {
          resp.fetchCountData = val;
        });
      }      
      );
    }
    return resp;
  }



}