import 'dart:math';
import 'package:aes_crypt/aes_crypt.dart';
import 'package:flutter_secure_storage/flutter_secure_storage.dart';
import 'dart:io' as io;

class DfSecurity {

  static secureOpenFile(String fileName) async {
    String finalFileName = "$fileName.aes";
    if (io.File(finalFileName).existsSync()) {
      var crypt = AesCrypt(await getSecureKey());
      crypt.decryptFileSync(finalFileName);
      var encFile = io.File(finalFileName);
      encFile.deleteSync();
    }
  }

    static secureCloseFile(String fileName) async {
    print("invoke to secureCloseFile");
    if (io.File(fileName).existsSync()) {
      var crypt = AesCrypt(await getSecureKey());
      crypt.encryptFileSync(fileName);
      var plainFile = io.File(fileName);
      plainFile.deleteSync();
      print("complete secureCloseFile");
    }
  }

  static Future<String> getSecureKey() async {
    String keyName = "ingdaokey";
    final storage = new FlutterSecureStorage();
    String key = await storage.read(key: keyName);
    if (key == null) {
      String randStr = getRandomString(32);
      await storage.write(key: keyName, value: randStr);
      return randStr;
    }
    else {
      return key;
    }
  }

  static const _chars = 'AaBbCcDdEeFfGgHhIiJjKkLlMmNnOoPpQqRrSsTtUuVvWwXxYyZz1234567890';
  static Random _rnd = Random();

  static String getRandomString(int length) => String.fromCharCodes(Iterable.generate(
    length, (_) => _chars.codeUnitAt(_rnd.nextInt(_chars.length))));

}